% Parametri del sistema
m = 10;
b = 15;
g = 9.81;
L = 1;

% Stato di equilibrio e corrispondente ingresso
xbar = [pi/4 0];
ubar = m*g;

% Uscita di equilibrio
ybar = xbar(1);

% Variazione delle condizioni iniziali
dx0 = [0.3 3];

% Variazione dell'ingresso, del tipo: Am*sin(t)
Am = 10;

% Intervallo di simulazione
tfin = 15;

% Matrici del modello linearizzato
A = [ 0 1 ; -sqrt(2)*g/L -b/(m*L^2) ];
B = [ 0 ; 1/(sqrt(2)*m*L) ];
C = [ 1 0 ];
D = 0;

% Costruzione del modello linearizzato
sys_l = ss(A,B,C,D);
% Intervallo di integrazione per la simulazione lineare
tlin = 0:.001:tfin;
% Simulazione lineare
du = Am*sin(tlin);
ylin= lsim(sys_l,du,tlin,dx0);
% Simulazione non lineare
[t,x_nl]=ode45('p_nl',[0 tfin],xbar+dx0,[],m,b,g,L,ubar,Am);
y_nl = x_nl(:,1);
% Grafico
figure(1)
plot(t,y_nl*180/pi,'-',tlin,(ylin+ybar)*180/pi,'--')
grid on
ylabel('[deg]')
xlabel('tempo [s]')
title('\theta')
legend('NL','L')